package dev.shadowsoffire.apotheosis.adventure.boss;

import com.mojang.datafixers.kinds.Applicative;
import java.util.Arrays;
import java.util.function.ToIntFunction;
import java.util.function.Function;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import com.mojang.serialization.Codec;
import dev.shadowsoffire.placebo.json.RandomAttributeModifier;
import dev.shadowsoffire.placebo.json.ChancedEffectInstance;
import java.util.List;

record BossStats(float enchantChance, int[] enchLevels, List<ChancedEffectInstance> effects, List<RandomAttributeModifier> modifiers) {
    public static final Codec<BossStats> CODEC;
    
    static {
        CODEC = RecordCodecBuilder.create(inst -> inst.group((App)Codec.FLOAT.fieldOf("enchant_chance").forGetter((Function)BossStats::enchantChance), (App)Codec.INT.listOf().xmap(l -> l.stream().mapToInt(Integer::intValue).toArray(), arr -> Arrays.stream(arr).boxed().toList()).fieldOf("enchantment_levels").forGetter((Function)BossStats::enchLevels), (App)ChancedEffectInstance.CODEC.listOf().fieldOf("effects").forGetter((Function)BossStats::effects), (App)RandomAttributeModifier.CODEC.listOf().fieldOf("attribute_modifiers").forGetter((Function)BossStats::modifiers)).apply((Applicative)inst, BossStats::new));
    }
}
